<template>
  <NuxtLayout :name="'dashboard'">
    <div class="flex justify-evenly container p-8">
      <div class="p-2 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
        <DynamicForm :fields="fields" :formTitle="formTitle" :submitName="submitName" :onSubmit="onSubmit" />
      </div>
      <!-- <div class="p-2 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
        <CameraCapture />
      </div> -->
    </div>
  </NuxtLayout>
</template>

<script lang="ts">
definePageMeta({
  middleware: ["auth"],
});

interface formTemplate {
  name: string;
  username: string;
  email: string;
  password: string;
  role: string;
}

export default {
  middleware: "auth",
  data() {
    return {
      toastVisible: false,
      toastTitle: "",
      toastMessage: "",
      formTitle: "Profile Data",
      submitName: "Save",
      isLoading: false,
      role: '',
      category: '',
      fields: [
        { id: "name", name: "Nama", type: "text", value: "" },
        {
          id: "gender", name: "Jenis Kelamin", type: "select", value: "", options: [
            { name: 'Pilih Kelamin', value: '' },
            { name: 'Laki-laki', value: 'male' },
            { name: 'Perempuan', value: 'female' }
          ]
        },
        { id: "birth_place", name: "Tempat Lahir", type: "text", value: "" },
        { id: "birth_date", name: "Tanggal Lahir", type: "date", value: "" },
        { id: "nik", name: "NIK", type: "text", value: "" },
        { id: "nationality", name: "Kewarganegaraan", type: "text", value: "" },
        { id: "religion", name: "Agama", type: "text", value: "" },
        { id: "job", name: "Pekerjaan", type: "text", value: "" },
        { id: "address", name: "Alamat", type: "text", value: "" },
        { id: "username", name: "Username", type: "text", value: "" },
        { id: "email", name: "Email", type: "email", value: "" },
        { id: "password", name: "Password", type: "password", value: "" },
        { id: "salary", name: "Salary", type: "number", value: "" },
      ],
      formData: {} as formTemplate,
    };
  },
  mounted() {
    this.fetchData();
  },
  methods: {
    fetchData() {
      const toastStore = useToastStore();
      const userStore = useUserDataStore();
      const accessToken: string = localStorage.getItem("access_token")!;

      this.$api
        .get(`/user/${userStore.userId}`, {
          headers: {
            Authorization: `Bearer ${accessToken}`,
          },
        })
        .then((response) => {
          let data = response.data;
          data.role = data.role.name;
          this.role = data.role;
          this.category = data.category;
          delete data.role.name;
          this.formToField(response.data);
        })
        .catch((error) => {
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger');
        }).finally(() => {
          this.isLoading = false;
        })
    },
    fieldsToForm(fields: typeof this.fields) {
      fields.forEach((field) => {
        // Check if the field.id exists as a property in the form object
        if (this.formData.hasOwnProperty(field.id)) {
          this.formData[field.id as keyof formTemplate] = field.value;
        }
      });
    },
    formToField(form: formTemplate) {
      this.fields.forEach((field) => {
        // Check if the field.id exists as a property in the form object
        if (form.hasOwnProperty(field.id)) {
          if (field.id !== "password")
            field.value = form[field.id as keyof formTemplate];
        }
      });
    },
    onSubmit(data: formTemplate) {
      this.isLoading = true;
      const toastStore = useToastStore();
      const userStore = useUserDataStore();
      const accessToken: string = localStorage.getItem("access_token")!;

      this.$api
        .put(`/user/${userStore.userId}`, { ...data, role: this.role, category: this.category }, {
          headers: {
            Authorization: `Bearer ${accessToken}`,
          }
        })
        .then((response) => {
          toastStore.showToast('Account updated successfully', 'success');
        })
        .catch((error) => {
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger');
        }).finally(() => {
          this.isLoading = false;
        })
    },
  },
};
</script>
